#include "header.h"
using namespace STDP;

const int Mapa::Dificultades[] = {99,95,90,80};

Mapa::Mapa()
{
	for(int f=0;f<kALTO;f++) { for(int c=0;c<kANCHO;c++) { mapa[f][c]=0; } }
	dif=1;
}

void Mapa::ponerminas()//trucado DESTRUCAR
{
	for(int f=2;f<kALTO-3;f++)
	{
		for(int c=0;c<kANCHO;c++)
		{
			if(rand()%100>Dificultades[dif-1])	{ mapa[f][c]=1; }
			else								{ mapa[f][c]=0; }
}	}	}

void Mapa::pintarmapa()
{
	//Ajustes iniciales
	StdPijo& stdp = StdPijo::p();
	stdp.init();

	for(int fila=0;fila<kALTO;fila++)
	{
		int alt=0;
		for (int col=0;col<kANCHO*2;col+=2)
		{
			stdp.setCursor(col,fila);

			if(fila==0) { stdp.setColor(ABOLD, CBLACK, CBLUE); stdp.writeStr("LL"); }

			else if(fila==kALTO-2) { stdp.setColor(ABOLD, CBLACK, CBLUE); stdp.writeStr("TT"); }

			else if(fila==kALTO-1) { stdp.setColor(ABOLD, CGREEN, CBLACK); stdp.writeStr("  "); }

			else if(fila%2==0)
			{
				if(alt%2==0)	{stdp.setColor(ABOLD, CBLACK, CRED); stdp.writeStr("  "); alt++;}
				else			{stdp.setColor(ABOLD, CRED, CBLACK); stdp.writeStr("  "); alt++;}
			}
			else
			{
				if(alt%2==0)	{stdp.setColor(ABOLD, CRED, CBLACK); stdp.writeStr("  "); alt++;}
				else			{stdp.setColor(ABOLD, CBLACK, CRED); stdp.writeStr("  "); alt++;}
			}
			stdp.refreshScr();
}	}	}

int Mapa::detectar()
{
	int minasdet=0;

	for(int f=(nave.getY()-1);f<(nave.getY()+2);f++)
	{
		for(int c=(nave.getX()-1);c<(nave.getX()+2);c++)
		{
			if(!(f==nave.getY() && c==nave.getX()) && mapa[f][c]) { minasdet++; }
		}
	}

	return(minasdet);
}

bool Mapa::explota()
{
	if(mapa[nave.getY()][nave.getX()])	{ pintarminas(); return 1; }
	else								{ return 0; }
}

void Mapa::pintarminas()
{
	//Ajustes iniciales
	StdPijo& stdp = StdPijo::p();
	stdp.init();

	for(int f=0;f<kALTO;f++)
	{
		for(int c=0;c<kANCHO;c++)
		{
			if(mapa[f][c])
			{
				stdp.setCursor((c*2),f);
				stdp.setColor(ABOLD, CRED, CYELLOW);
				stdp.writeStr("TT");
				usleep(10000);
				stdp.refreshScr();
}	}	}	}

bool Mapa::win()
{
	if(nave.getY()==0)	{ return 1; }
	else				{ return 0; }
}

void Mapa::Juego(Nave nave)
{
	StdPijo& stdp = StdPijo::p();
	stdp.init();

	bool final = 0;

	do
	{
		nave.set0();

		ponerminas();

		pintarmapa();

		time_t tiempo = time(NULL);

		do
		{
			nave.imprimir();
			nave.mover();
			copianave(nave);

			stdp.setCursor(0,23); stdp.setColor(ABOLD, CGREEN, CBLACK); stdp.writeStr("Minas: ");

			stringstream ss; ss << detectar(); string resultado=ss.str(); stdp.writeStr(resultado.c_str());

			stdp.refreshScr();
		}while(!explota() && !win());

		if(explota())
		{
			pintarminas();

			usleep(1000000);

			final=Menu::GameOver();
		}

		if(win())
		{
			puntuacion = 100 - (time(NULL) - tiempo);
			Menu::Win(puntuacion);
			final=1;
		}
	}while(!final);
}

void Mapa::Desbloquear(Jugador &player)
{
	StdPijo& stdp = StdPijo::p();
	stdp.init();

	switch(dif)
	{
	case 1: player.setDesbNormal(1); break;
	case 2: player.setDesbDificil(1); break;
	case 3: player.setDesbMDificil(1); break;
	}
}


